import bpy
from .t3dn_bip.utils import support_pillow, support_beautifulsoup
from .utils import __7__

from bpy.types import (
    AddonPreferences,
    )
from bpy.props import (
    StringProperty,
    )

class FM_Pref(AddonPreferences):
    bl_idname = __package__
    
    downloads_folder : StringProperty(
        name="下载文件夹",
        description="Where you want the downloaded fonts to live",
        default=__7__(),
        subtype="DIR_PATH"
        )
        
    font_folder : StringProperty(
        name="Font Folder",
        description="Path to the font folder/library",
        default="",
        subtype="DIR_PATH"
        )

    def draw(self, context):
        layout = self.layout
        
        box = layout.box()
        row = box.row()
        col = row.column()
        col.prop(self, "downloads_folder", text="字体下载文件夹")
        row = box.row()
        col = row.column()
        col.prop(self, "font_folder", text="自定义字体文件夹")
        
        col = layout.column(align=True)
        if not support_pillow() or not support_beautifulsoup():
            col.scale_y = 1.4
            text = 'Install Dependencies for Better performance and Web Font access'
            col.operator('fm.bip_showcase_install_dependencies', text=text, icon='ERROR')
        else:
            text = 'Update Dependencies'
            col.operator('fm.bip_showcase_install_dependencies', text=text, icon='FILE_REFRESH')
        

classes = (FM_Pref,)


def register():
    for cls in classes:
        bpy.utils.register_class(cls)


def unregister():
    for cls in reversed(classes):
        bpy.utils.unregister_class(cls)