import bpy
from .t3dn_bip.utils import support_pillow, support_beautifulsoup
from . import utils
import json

class FM_PT_bip_showcase_panel(bpy.types.Panel):
    bl_idname = 'FM_PT_bip_showcase_panel'
    bl_label = 'Quick Font Pro'
    bl_category = 'Quick Font Pro'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'

    def draw(self, context: bpy.types.Context):
        fm_props = utils.__e__()
        
        layout = self.layout
        
        if not support_pillow() or not support_beautifulsoup():
            col = layout.column(align=True)
            col.scale_y = 1.4
            text = 'Install Dependencies!'
            col.operator('fm.bip_showcase_install_dependencies', text=text, icon='ERROR')
        
        row = layout.row()
        row.scale_y = 1.4
        row.prop(fm_props, "tab", expand=True)
        
        thumbSize = fm_props.thumb_size
        
        if fm_props.tab == "4":
            if support_beautifulsoup() and support_pillow():
                row = layout.row(align=True)
                _icon = "TRIA_DOWN"
                _text = "显示分类选项"
                if fm_props.web_categories:
                    _icon = "TRIA_UP"
                    _text = "Hide Categories"
                row.prop(fm_props, "web_categories", text=_text, icon=_icon, toggle=True)
                _icon = "TRIA_DOWN"
                _text = "显示Web搜索筛选器"
                if fm_props.web_search_filters:
                    _icon = "TRIA_UP"
                    _text = "隐藏Web搜索筛选器"
                row.prop(fm_props, "web_search_filters", text=_text, icon=_icon, toggle=True)
                
                if fm_props.web_categories:
                    box = layout.row().box()
                    row = box.row(align=True)
                    row.label(text="Categories:")
                    row.operator('fm.category', text="重置类别过滤").cat=99
                    
                    grid = box.grid_flow(row_major=True)
                    
                    g = grid.grid_flow(row_major=True)
                    row = g.row()
                    row.label(text="Fancy:")
                    g = grid.box().grid_flow(row_major=True)
                    row = g.row()
                    row.operator('fm.category', text="Cartoon").cat=101
                    row = g.row()
                    row.operator('fm.category', text="Comic").cat=102
                    row = g.row()
                    row.operator('fm.category', text="Groovy").cat=103
                    row = g.row()
                    row.operator('fm.category', text="Old School").cat=104
                    row = g.row()
                    row.operator('fm.category', text="Curly").cat=105
                    row = g.row()
                    row.operator('fm.category', text="Western").cat=106
                    row = g.row()
                    row.operator('fm.category', text="Eroded").cat=107
                    row = g.row()
                    row.operator('fm.category', text="Distorted").cat=108
                    row = g.row()
                    row.operator('fm.category', text="Destroy").cat=109
                    row = g.row()
                    row.operator('fm.category', text="Horror").cat=110
                    row = g.row()
                    row.operator('fm.category', text="Fire, Ice").cat=111
                    row = g.row()
                    row.operator('fm.category', text="Decorative").cat=112
                    row = g.row()
                    row.operator('fm.category', text="Typewriter").cat=113
                    row = g.row()
                    row.operator('fm.category', text="Stencil, Army").cat=114
                    row = g.row()
                    row.operator('fm.category', text="Retro").cat=115
                    row = g.row()
                    row.operator('fm.category', text="Initials").cat=116
                    row = g.row()
                    row.operator('fm.category', text="Grid").cat=117
                    row = g.row()
                    row.operator('fm.category', text="Fancy Various").cat=118
                    
                    g = grid.grid_flow(row_major=True)
                    row = g.row()
                    row.label(text="Foreign look:")
                    g = grid.box().grid_flow(row_major=True)
                    row = g.row()
                    row.operator('fm.category', text="Chinese, Jpn").cat=201
                    row = g.row()
                    row.operator('fm.category', text="Arabic").cat=202
                    row = g.row()
                    row.operator('fm.category', text="Mexican").cat=203
                    row = g.row()
                    row.operator('fm.category', text="Roman, Greek").cat=204
                    row = g.row()
                    row.operator('fm.category', text="Russian").cat=205
                    row = g.row()
                    row.operator('fm.category', text="Foreign look Various").cat=206
                    
                    g = grid.grid_flow(row_major=True)
                    row = g.row()
                    row.label(text="Techno:")
                    g = grid.box().grid_flow(row_major=True)
                    row = g.row()
                    row.operator('fm.category', text="Square").cat=301
                    row = g.row()
                    row.operator('fm.category', text="LCD").cat=302
                    row = g.row()
                    row.operator('fm.category', text="Sci-fi").cat=303
                    row = g.row()
                    row.operator('fm.category', text="Techno Various").cat=304
                    
                    g = grid.grid_flow(row_major=True)
                    row = g.row()
                    row.label(text="Gothic:")
                    g = grid.box().grid_flow(row_major=True)
                    row = g.row()
                    row.operator('fm.category', text="Medieval").cat=401
                    row = g.row()
                    row.operator('fm.category', text="Modern").cat=402
                    row = g.row()
                    row.operator('fm.category', text="Celtic").cat=403
                    row = g.row()
                    row.operator('fm.category', text="Initials").cat=404
                    row = g.row()
                    row.operator('fm.category', text="Gothic Various").cat=405
                    
                    g = grid.grid_flow(row_major=True)
                    row = g.row()
                    row.label(text="Basic:")
                    g = grid.box().grid_flow(row_major=True)
                    row = g.row()
                    row.operator('fm.category', text="Sans serif").cat=501
                    row = g.row()
                    row.operator('fm.category', text="Serif").cat=502
                    row = g.row()
                    row.operator('fm.category', text="Fixed width").cat=503
                    row = g.row()
                    row.operator('fm.category', text="Basic Various").cat=504
                    
                    g = grid.grid_flow(row_major=True)
                    row = g.row()
                    row.label(text="Script:")
                    g = grid.box().grid_flow(row_major=True)
                    row = g.row()
                    row.operator('fm.category', text="Calligraphy").cat=601
                    row = g.row()
                    row.operator('fm.category', text="School").cat=602
                    row = g.row()
                    row.operator('fm.category', text="Handwritten").cat=603
                    row = g.row()
                    row.operator('fm.category', text="Brush").cat=604
                    row = g.row()
                    row.operator('fm.category', text="Trash").cat=605
                    row = g.row()
                    row.operator('fm.category', text="Graffiti").cat=606
                    row = g.row()
                    row.operator('fm.category', text="Old School").cat=607
                    row = g.row()
                    row.operator('fm.category', text="Script Various").cat=608
                    
                    g = grid.grid_flow(row_major=True)
                    row = g.row()
                    row.label(text="Dingbats:")
                    g = grid.box().grid_flow(row_major=True)
                    row = g.row()
                    row.operator('fm.category', text="Alien").cat=701
                    row = g.row()
                    row.operator('fm.category', text="Animals").cat=702
                    row = g.row()
                    row.operator('fm.category', text="Asian").cat=703
                    row = g.row()
                    row.operator('fm.category', text="Ancient").cat=704
                    row = g.row()
                    row.operator('fm.category', text="Runes, Elvish").cat=705
                    row = g.row()
                    row.operator('fm.category', text="Esoteric").cat=706
                    row = g.row()
                    row.operator('fm.category', text="Fantastic").cat=707
                    row = g.row()
                    row.operator('fm.category', text="Horror").cat=708
                    row = g.row()
                    row.operator('fm.category', text="Games").cat=709
                    row = g.row()
                    row.operator('fm.category', text="Shapes").cat=710
                    row = g.row()
                    row.operator('fm.category', text="Bar Code").cat=711
                    row = g.row()
                    row.operator('fm.category', text="Nature").cat=712
                    row = g.row()
                    row.operator('fm.category', text="Sport").cat=713
                    row = g.row()
                    row.operator('fm.category', text="Heads").cat=714
                    row = g.row()
                    row.operator('fm.category', text="Kids").cat=715
                    row = g.row()
                    row.operator('fm.category', text="TV, Movie").cat=716
                    row = g.row()
                    row.operator('fm.category', text="Logos").cat=717
                    row = g.row()
                    row.operator('fm.category', text="Sexy").cat=718
                    row = g.row()
                    row.operator('fm.category', text="Army").cat=719
                    row = g.row()
                    row.operator('fm.category', text="Music").cat=720
                    row = g.row()
                    row.operator('fm.category', text="Dingbats Various").cat=721
                    
                    g = grid.grid_flow(row_major=True)
                    row = g.row()
                    row.label(text="Holiday:")
                    g = grid.box().grid_flow(row_major=True)
                    row = g.row()
                    row.operator('fm.category', text="Valentine").cat=801
                    row = g.row()
                    row.operator('fm.category', text="Easter").cat=802
                    row = g.row()
                    row.operator('fm.category', text="Halloween").cat=803
                    row = g.row()
                    row.operator('fm.category', text="Christmas").cat=804
                    row = g.row()
                    row.operator('fm.category', text="Holiday Various").cat=805
                    
                    g = grid.grid_flow(row_major=True)
                    row = g.row()
                    row.label(text="Pixel, Bitmap:")
                    g = grid.box().grid_flow(row_major=True)
                    row = g.row()
                    row.operator('fm.category', text="Pixel, Bitmap").cat=900

                    
                if fm_props.web_search_filters:
                    box = layout.row().box()
                    row = box.row()
                    sub = row.row(align=True)
                    sub.prop(fm_props, "numFonts", text="字体/每页数")
                    sub = row.row()
                    sub.prop(fm_props, "sortBy")
                    
                    row = box.row()
                    row.label(text="仅展示:")
                    grid = box.grid_flow(row_major=True)
                    row = grid.row()
                    row.prop(fm_props, "show_pD", text="免费GPL证书", icon="USER")
                    row = grid.row()
                    row.prop(fm_props, "show_fR", text="Free", icon="BLENDER")
                    row = grid.row()
                    row.prop(fm_props, "show_pU", text="仅个人使用", icon="FAKE_USER_ON")
                    row = grid.row()
                    row.prop(fm_props, "show_dW", text="捐助使用", icon="FUND")
                    row = grid.row()
                    row.prop(fm_props, "show_sW", text="共享软件", icon="FAKE_USER_OFF")
                    row = grid.row()
                    row.prop(fm_props, "show_dM", text="Demo", icon="FONT_DATA")
                    row = grid.row()
                    row.prop(fm_props, "show_uK", text="Unknown", icon="HELP")
                    
                    row = box.row()
                    row.operator("fm.apply_filters", icon="FILTER")
                
                row = layout.row(align=True)
                row.prop(fm_props, "web_search", text="", icon="VIEWZOOM")
                
                row = layout.row(align=True)
                row.label(text="Columns:")
                row.prop(fm_props, "thumb_size", text="")
                
                page = fm_props.active_page
                pageText = "Page: "+utils.__v__(page)
                
                fonts_data = utils.__h__()
                if fonts_data:
                    fonts = fonts_data['fonts']
                    pageText = pageText+"/"+str(fonts_data['end_page'])
                    links = fonts_data['relative_links']
                    next_link = ''
                    prev_link = ''
                    if links['next_link']:
                        next_link = links['next_link']
                    if links['prev_link']:
                        prev_link = links['prev_link']
                    fm_props.next_page = next_link
                    fm_props.prev_page = prev_link
                    
                    icons = utils.__d__(self,context,fonts)
                    
                    if icons:
                        row = layout.row()
                        row.scale_y = 1.2
                        sub = row.row(align=True)                    
                        sub.label(text=pageText)
                        sub = row.row(align=True) 
                        sub.prop(fm_props, "go_to_page", text="")
                        sub.operator('fm.jump_to_page', text="", icon='LOOP_FORWARDS').pMax = fonts_data['end_page']
                        sub = row.row(align=True) 
                        sub.operator('fm.visit_prev', text="上一页", icon='TRIA_LEFT')
                        sub.operator('fm.visit_next', text="下一页", icon='TRIA_RIGHT')
                        
                        layout.separator()
                        
                        grid = layout.grid_flow(row_major=True, columns=(thumbSize*2))

                        wm = context.window_manager
                        downloading_fonts = wm.downloading_fonts.split(',')
                        downloaded_fonts, favourite_fonts = utils.__s__()

                        for icon in icons:
                            preview = icon[0]
                            icon_id = preview.icon_id

                            trow = grid.row().box()
                            trow.template_icon(icon_value=icon_id, scale=10)
                            
                            _license = icon[2]
                            license_icon = 'HELP'
                            license_text = '未知'
                            if _license == "公众域 / GPL / OFL":
                                license_icon = "USER"
                                license_text = "免费开源GPL"
                            if _license == "100% Free":
                                license_icon = "BLENDER"
                                license_text = "免费"
                            if _license == "Free for personal use":
                                license_icon = "FAKE_USER_ON"
                                license_text = "仅供个人使用"
                            if _license == "Donationware":
                                license_icon = "FUND"
                                license_text = "捐助使用"
                            if _license == "Shareware":
                                license_icon = "FAKE_USER_OFF"
                                license_text = "共享的"
                            if _license == "Demo":
                                license_icon = "FONT_DATA"
                                license_text = "演示"

                            row = trow.row()
                            row.label(text=license_text, icon=license_icon)
                            
                            brow = trow.row(align=True)
                            brow.scale_y = 1.2
                            
                            row = brow.row()

                            font_name = icon[3]

                            is_downloading = font_name in downloading_fonts
                            is_downloaded = font_name in downloaded_fonts
                            is_fav = False
                            _font_path = None
                            if is_downloaded:
                                font_path = utils.__c__(font_name)
                                _font_path = font_path[0]
                                is_fav = _font_path in favourite_fonts

                            mtext = icon[1]
                            micon='IMPORT'
                            if is_downloading:
                                mtext = "Downloading"
                                micon = "SORTTIME"
                            if is_downloaded:
                                mtext = ""
                                micon = "FILE_FONT"
                            op = row.operator('fm.download_font', text=mtext, icon=micon)
                            op.font = font_name

                            row.enabled = not is_downloading and not is_downloaded
                            
                            if is_downloaded:
                                row = brow.row()
                                row.operator("fm.font_use", icon='PLAY', text="Apply").font = font_name
                            
                                row = brow.row()
                                if is_fav:
                                    row.operator("fm.favourite", icon='SOLO_ON', text="").font = font_name
                                else:
                                    row.operator("fm.favourite", icon='SOLO_OFF', text="").font = font_name
                                    
                                row = brow.row()
                                row.operator("fm.delete",icon="TRASH", text="").font = font_name
                            
                            row = brow.row()
                            row.operator("fm.font_info", icon='URL', text="").font = font_name

                            grid.separator()
                            
                        row = layout.row()
                        row.scale_y = 1.2
                        sub = row.row(align=True)                    
                        sub.label(text=pageText)
                        sub = row.row(align=True) 
                        sub.prop(fm_props, "go_to_page", text="")
                        sub.operator('fm.jump_to_page', text="", icon='LOOP_FORWARDS').pMax = fonts_data['end_page']
                        sub = row.row(align=True) 
                        sub.operator('fm.visit_prev', text="上一页", icon='TRIA_LEFT')
                        sub.operator('fm.visit_next', text="下一页", icon='TRIA_RIGHT')
                    else:
                        row = layout.row()
                        row.label(text="没有可用的字体!", icon="ERROR")
                else:
                    row = layout.row()
                    row.label(text="检查您的互联网连接!", icon="ERROR")
            else:
                row = layout.row()
                row.label(text = '安装Web字体访问的依赖项', icon="ERROR")
                
        else:
            row = layout.row()
            row.prop(fm_props, "views", expand=True)
            
            row = layout.row(align=True)
            row.prop(fm_props, "search", text="", icon="VIEWZOOM")
            
            if fm_props.views == '1':
                row = layout.row(align=True)
                row.label(text="Columns:")
                row.prop(fm_props, "thumb_size", text="")
                
                if fm_props.tab == "3":
                    if bpy.context.preferences.addons[__package__].preferences.downloads_folder == utils.__7__():
                        row = layout.row()
                        row.label(text="您可以在插件首选项中更改下载的字体文件夹", icon="INFO")
                    
                if fm_props.tab == "5":
                    if bpy.context.preferences.addons[__package__].preferences.font_folder == "":
                        row = layout.row()
                        row.label(text="在插件首选项中选择/更改文件夹", icon="INFO")
                
                layout.separator()
                
                grid = layout.grid_flow(row_major=True, columns=(thumbSize*2))
                
                icons = utils.__b__(self,context)
                
                downloaded_fonts, favourite_fonts = utils.__s__()
                
                if icons:
                    for icon in icons:
                        preview = icon[0]
                        font_name = icon[1]

                        icon_id = preview.icon_id
                        row = grid.row().box()
                        
                        row.template_icon(icon_value=icon_id, scale=8)
                        row = row.row(align=True)
                        row.scale_y = 1.2
                        row.operator('fm.apply_font', text=font_name, icon='TRACKING_REFINE_BACKWARDS').Font = icon[2]
                        if icon[2] in favourite_fonts:
                            row.operator("fm.favourite", icon='SOLO_ON', text="").font = icon[2]
                        else:
                            row.operator("fm.favourite", icon='SOLO_OFF', text="").font = icon[2]
                        grid.separator()
                else:
                    row = layout.row()
                    row.label(text="没有可用的字体!", icon="ERROR")
            
            if fm_props.views == '2':
                if fm_props.tab == "5":
                    row = layout.row()
                    row.label(text="在插件首选项中选择/更改文件夹")
                    
                layout.separator()
                
                fonts = utils.__a__()
                
                if utils.__z__(fonts):
                    wm = context.window_manager

                    row = layout.row()
                    row.template_list("FM_UL_items", "", wm, "fm_fonts_collection", wm, "fm_fonts_collection_index", rows=10)
                

class FM_UL_items(bpy.types.UIList):
    def __init__(self):
        fm_props = utils.__e__()
        self.filter_name = fm_props.search
        
    def draw_item(self, context, layout, data, item, icon, active_data, active_property, index):
        downloaded_fonts, favourite_fonts = utils.__s__()
        font = item
        if self.layout_type in {'DEFAULT', 'COMPACT'}:
            layout.label(text=font.name, icon="FILE_FONT")
            if font.path in favourite_fonts:
                layout.operator("fm.favourite", icon='SOLO_ON', text="").font = font.path
            else:
                layout.operator("fm.favourite", icon='SOLO_OFF', text="").font = font.path
        elif self.layout_type == 'GRID':
            layout.label(text=font.name, icon="FILE_FONT")
            if font.path in favourite_fonts:
                layout.operator("fm.favourite", icon='SOLO_ON', text="").font = font.path
            else:
                layout.operator("fm.favourite", icon='SOLO_OFF', text="").font = font.path
            
            
    def draw_filter(self, context, layout):
        row = layout.row()
        sub = row.row(align= True)
        sub.prop(self, "filter_name", text="")
        sub.prop(self, "use_filter_invert", text="", icon="ARROW_LEFTRIGHT")
        sub = row.row(align= True)
        sub.prop(self, "use_filter_sort_alpha", text="", icon="SORTALPHA")
        sub.prop(self, "use_filter_sort_reverse", text="", toggle=True, icon="SORT_ASC")
                

classes = (FM_PT_bip_showcase_panel,FM_UL_items,)


def register():
    for cls in classes:
        bpy.utils.register_class(cls)


def unregister():
    for cls in reversed(classes):
        bpy.utils.unregister_class(cls)
