import bpy
from .t3dn_bip.utils import support_beautifulsoup
from typing import List, Tuple
from . import previews
import os
import platform
import requests
import urllib.request
from urllib.parse import urlparse, parse_qs, urlencode, urlunparse
import json
import threading
import time
from pathlib import Path
import math
import zipfile
import re
import random
import shutil
        
def __a__(a=False):
    fonts = []
    fontNames = []
    font_dirs = []
    
    fm_props = __e__()
    
    if a:
        path = bpy.context.preferences.addons[__package__].preferences.downloads_folder
        font_dirs = [path]
    else:
        if fm_props.tab == "2":
            system = platform.system()
            if system == "Windows":
                font_dirs = ["C:\\Windows\\Fonts"]
            elif system == "Darwin":
                font_dirs = ["/Library/Fonts", "/System/Library/Fonts"]
            elif system == "Linux":
                font_dirs = ["/usr/share/fonts", "/usr/local/share/fonts"]
        
        if fm_props.tab == "3":
            path = bpy.context.preferences.addons[__package__].preferences.downloads_folder
            font_dirs = [path]
            
        if fm_props.tab == "5":
            path = bpy.context.preferences.addons[__package__].preferences.font_folder
            font_dirs = [path]
            
        if fm_props.tab == "1":
            font_paths = __s__()[1] 
    
    if fm_props.tab == "1":
        for font_file in font_paths:
            if font_file.lower().endswith(('.ttf', '.otf', '.ttc')):
                fonts.append(font_file)
                font_name = os.path.splitext(os.path.basename(font_file))[0]
                fontNames.append(font_name)
    else:
        for font_dir in font_dirs:
            if os.path.isdir(font_dir):
                for root, dirs, files in os.walk(font_dir):
                    for font_file in files:
                        if font_file.lower().endswith(('.ttf', '.otf', '.ttc')):
                            font_path = os.path.join(root, font_file)
                            fonts.append(font_path)
                            fontNames.append(os.path.splitext(font_file)[0])
    
    ret = [fonts,fontNames]
    return ret

_icons: List[Tuple[str, str, str, int, int]] = []
    
def __b__(self, context: bpy.types.Context):
    _icons.clear()
    
    ret = __a__()
    
    paths = ret[0]
    names = ret[1]
    searchTerm = __e__().search

    for index, path in enumerate(list(paths)):
        icon = previews.collection.load_safe(names[index], str(path), 'FONT')
        name = names[index]
        
        if searchTerm == "":
            _icons.append([icon,name,path])
        elif searchTerm.lower() in name.lower():
            _icons.append([icon,name,path])

    return _icons
    
def __c__(a):
    ret = __a__(True)
    
    paths = ret[0]
    names = ret[1]
    
    p = []

    for index, path in enumerate(list(paths)):
        name = names[index]
        if a.lower() in name.lower():
            p.append(path)

    return p
    
def __d__(self, context: bpy.types.Context, a):
    _icons.clear()

    _dir = os.path.dirname(os.path.abspath(__file__))
    thumb_dir = os.path.join(_dir, "web", "thumbs")
        
    if a:
        for font in a:
            save_name = font['thumbnail_url'].split('/')[-1]
            thumb_filename = os.path.join(thumb_dir, save_name)
            
            icon = previews.collection.load_safe(save_name, thumb_filename, 'IMAGE')
            _icons.append([icon,font['name'],font['license_type'],save_name.split('.')[0]])

    return _icons

def __e__():
    return bpy.context.window_manager.fm_props
    
def __f__(a):
    thumb_url = a.get('thumbnail_url')
    if thumb_url:        
        _dir = os.path.dirname(os.path.abspath(__file__))
        thumb_dir = os.path.join(_dir, "web", "thumbs")
        
        os.makedirs(thumb_dir, exist_ok=True)
        
        save_name = thumb_url.split('/')[-1]
        
        thumb_filename = os.path.join(thumb_dir, save_name)
        
        if os.path.exists(thumb_filename):
            return
        
        try:
            response = requests.get(thumb_url, stream=True)
            response.raise_for_status()
            
            with open(thumb_filename, 'wb') as file:
                for chunk in response.iter_content(1024):
                    file.write(chunk)
        except requests.exceptions.RequestException as e:
            pass

            
def __g__(a):
    threads = []
    for font in a:
        thread = threading.Thread(target=__f__, args=(font,))
        thread.start()
        threads.append(thread)
    
def __h__():
    fm_props = __e__()
    page = fm_props.active_page
    cached_data = __o__()
    if cached_data and cached_data.get('font_page') == page and not fm_props.hot_reload:
        return cached_data
    
    fm_props.hot_reload = False
    bpy.context.window.cursor_set("WAIT")
    url = f"https://www.dafont.com"+fm_props.active_page
    url = __5__(url)
    html_content = __i__(url)
    if html_content:
        bpy.context.window.cursor_set("DEFAULT")
        soup = __j__(html_content)
        if soup:
            fonts = __l__(soup)
            next_link, prev_link = __m__(soup)
            
            new_data = {
                "font_page": page,
                "relative_links": {
                    "next_link": next_link,
                    "prev_link": prev_link
                },
                "fonts": fonts,
                "end_page": __k__(soup)
            }
            __n__(new_data)
            __g__(fonts)
            return new_data
      
    bpy.context.window.cursor_set("DEFAULT")
    return None
    
user_agents = [
    'Mozilla/5.0 (Linux; Android 10; SM-A505FN) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/83.0.4103.106 Mobile Safari/537.36',
    'Mozilla/5.0 (Linux; U; Android 4.1.1; en-us; Nexus 7 Build/JRO03S) AppleWebKit/535.19 (KHTML, like Gecko) Chrome/18.0.1025.166 Safari/535.19',
    'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.15; rv:89.0) Gecko/20100101 Firefox/89.0',
    'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.15; rv:90.0) Gecko/20100101 Firefox/90.0',
    'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/14.0.3 Safari/605.1.15',
    'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/90.0.4430.212 Safari/537.36',
    'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/91.0.4472.124 Safari/537.36',
    'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/92.0.4515.107 Safari/537.36',
    'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Edge/91.0.864.67',
    'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:89.0) Gecko/20100101 Firefox/89.0',
    'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:90.0) Gecko/20100101 Firefox/90.0',
    'Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:89.0) Gecko/20100101 Firefox/89.0',
    'Mozilla/5.0 (iPad; CPU OS 13_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Mobile/15E148 Safari/604.1',
    'Mozilla/5.0 (iPhone; CPU iPhone OS 13_5_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Mobile/15E148 Safari/604.1',
    'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14'
]

def __i__(a):
    ua = random.choice(user_agents)
    headers = {
        'User-Agent': ua
    }
    try:
        response = requests.get(a, headers=headers)
        response.raise_for_status()
        return response.content
    except requests.exceptions.RequestException as e:
        return None

def __j__(a):
    if not a:
        return None
    if support_beautifulsoup():
        from bs4 import BeautifulSoup
        soup = BeautifulSoup(a, 'html.parser')
        return soup
    return None
    

def __k__(a):
    page_numbers = []

    links = a.find_all('a', href=re.compile(r'page=\d+'))
    for link in links:
        href = link.get('href')
        match = re.search(r'page=(\d+)', href)
        if match:
            page_number = int(match.group(1))
            page_numbers.append(page_number)

    if page_numbers:
        return max(page_numbers)
    return None

def __l__(a):
    if not a:
        return []
    fonts = []
    font_names = a.find_all('div', class_='lv1left dfbg')
    font_links = a.find_all('div', class_='dlbox')
    font_thumbs = a.find_all('div', class_='preview')
    font_licenses = a.find_all('div', class_='lv2right')
    
    for index,font_div in enumerate(font_names):
        name_tag = font_div.find('strong')
        if name_tag:
            font_name = name_tag.text.strip()
        else:
            full_text = font_div.get_text(separator='', strip=False)
            if 'by ' in full_text:
                font_name = re.sub('[à€$]', '', full_text.split('by ')[0].strip()).strip()
            else:
                font_name = 'Unknown'

        download_tag = font_links[index].find('a', class_='dl')
        download_link = download_tag['href'] if download_tag else 'No link'

        preview_tag = font_thumbs[index].find('div', class_='preview')
        style = font_thumbs[index]['style']
        thumbnail_url = ''
        if 'background-image:url(' in style:
            start = style.find('background-image:url(') + len('background-image:url(')
            end = style.find(')', start)
            thumbnail_url = style[start:end].strip('\'"')
            
        license_tag = font_licenses[index].find('a', class_='tdn help black')
        license_type = license_tag.text.strip() if license_tag else 'No license'
        
        creator_tag = font_div.find('a', class_='tdn', rel='nofollow')
        creator_url = creator_tag['href'] if creator_tag else 'No creator URL'

        fonts.append({
            'name': font_name,
            'download_link': download_link,
            'thumbnail_url': f"https://www.dafont.com{thumbnail_url}",
            'license_type': license_type,
            'creator_url': creator_url
        })
    return fonts

def __m__(a):
    if not a:
        return None, None
    next_link = prev_link = None
    next_tag = a.find('a', title='Keyboard shortcut: Right arrow')
    prev_tag = a.find('a', title='Keyboard shortcut: Left arrow')
    if next_tag:
        next_link = next_tag['href']
    if prev_tag:
        prev_link = prev_tag['href']
    return next_link, prev_link
    
def __n__(a):
    fm_props = __e__()
    json_data = json.dumps(a)
    fm_props.cached_page = json_data

def __o__():
    fm_props = __e__()
    if fm_props.cached_page != "":
        data = json.loads(fm_props.cached_page)
        return data
    return None
    
def __p__(a):
    parsed_url = urlparse(a)
    query_params = parse_qs(parsed_url.query)
    if 'f' in query_params:
        return f"{query_params['f'][0]}.zip"
    return "downloaded_file.zip"
    
def __q__(a, callback=None, b=None):
    font_dir = bpy.context.preferences.addons[__package__].preferences.downloads_folder

    os.makedirs(font_dir, exist_ok=True)

    file_name = __p__(a)
    save_path = os.path.join(font_dir, file_name)

    try:
        response = requests.get(a, stream=True)
        response.raise_for_status()

        total_size = int(response.headers.get('content-length', 0))
        block_size = 1024
        downloaded_size = 0

        with open(save_path, 'wb') as file:
            for data in response.iter_content(block_size):
                file.write(data)
                downloaded_size += len(data)
                if total_size > 0:
                    progress = math.ceil((downloaded_size / total_size) * 50)
                else:
                    pass

        succeeded = False
        append_to_filename = __3__(b)
        extracted_dirs = set()
        
        with zipfile.ZipFile(save_path, 'r') as zip_ref:
            for file_info in zip_ref.infolist():
                if file_info.filename.lower().endswith(('.ttf', '.otf', '.ttc')):
                    extracted_path = zip_ref.extract(file_info, font_dir)
                    succeeded = True

                    base_name, ext = os.path.splitext(os.path.basename(file_info.filename))
                    new_name = base_name + append_to_filename + ext
                    new_path = os.path.join(font_dir, new_name)
                    
                    os.rename(extracted_path, new_path)

                    extracted_dir = os.path.dirname(extracted_path)
                    if extracted_dir and extracted_dir != os.path.normpath(font_dir):
                        extracted_dirs.add(extracted_dir)

        if succeeded and b:
            if os.path.exists(save_path):
                os.remove(save_path)

            __u__(font_dir)

            fonts_list, favourites_list = __s__()
            fonts_list.add(b)
            __t__(fonts_list, favourites_list)

        for dir_path in extracted_dirs:
            try:
                os.rmdir(dir_path)
            except OSError:
                shutil.rmtree(dir_path, ignore_errors=True)

        if callback:
            callback(success=True, path=save_path)
    except requests.exceptions.RequestException as e:
        if callback:
            callback(success=False, error=str(e))

def __r__(a, callback=None, b=None):
    download_thread = threading.Thread(target=__q__, args=(a, callback, b))
    download_thread.start()
    
def __s__():
    _dir = bpy.context.preferences.addons[__package__].preferences.downloads_folder
    records_path = os.path.join(_dir, "records.json")
    if os.path.exists(records_path):
        with open(records_path, 'r') as records_file:
            data = json.load(records_file)
            fonts_list = set(data.get('fonts', []))
            favourites_list = set(data.get('favourites', []))
    else:
        fonts_list = set()
        favourites_list = set()
    
    return fonts_list, favourites_list
    
def __t__(a, b):
    _dir = bpy.context.preferences.addons[__package__].preferences.downloads_folder
    records_path = os.path.join(_dir, "records.json")
    data = {
        'fonts': sorted(a),
        'favourites': sorted(b)
    }
    with open(records_path, 'w') as records_file:
        json.dump(data, records_file, indent=4)
        
def __u__(a):
    fonts = {}
    for root, _, files in os.walk(a):
        for file in files:
            if file.lower().endswith(('.ttf', '.otf', '.ttc')):
                base_name = os.path.splitext(file)[0]
                ext = os.path.splitext(file)[1].lower()
                if base_name not in fonts or (fonts[base_name] == '.ttf' and ext == '.otf'):
                    fonts[base_name] = ext

    for root, _, files in os.walk(a):
        for file in files:
            base_name = os.path.splitext(file)[0]
            ext = os.path.splitext(file)[1].lower()
            if base_name in fonts and fonts[base_name] != ext:
                if "ttf" in ext:
                    os.remove(os.path.join(root, file))
                    
def __v__(a):
    parsed_url = urllib.parse.urlparse(a)
    
    query_params = urllib.parse.parse_qs(parsed_url.query)
    
    page_number = query_params.get('page', [None])[0]
    if page_number is not None:
        return page_number
    else:
        return None
        
def __w__(a="",b=""):
    fm_props = __e__()
    if a != "":
        base = '/search.php?q='+searchTerm
    fm_props.active_page = base
    
def __x__(self, context):
    for window in bpy.context.window_manager.windows:
        for area in window.screen.areas:
            if area.type in {'VIEW_3D', 'IMAGE_EDITOR', 'NODE_EDITOR', 'SEQUENCE_EDITOR'}:
                area.tag_redraw()

def __y__():
    fm_props = __e__()
    searchTerm = fm_props.web_search
    if searchTerm != "":
        fm_props.active_page = '/search.php?q='+searchTerm+'&page=1'
    else:
        fm_props.active_page = '/top.php?page=1'
        
def __z__(a):
    paths, names = a

    bpy.context.window_manager.fm_fonts_collection.clear()

    for path, name in zip(paths, names):
        item = bpy.context.window_manager.fm_fonts_collection.add()
        item.name = name
        item.path = path
        
    return True
    
def __0__(a, self=None):
    obList = []
    
    selected_objects = bpy.context.selected_objects
    for ob in selected_objects:
        if ob and ob.type == 'FONT':
            obList.append(ob.name)
            
    actObj = bpy.context.active_object
    if actObj.name not in obList and actObj.type == 'FONT':
        obList.append(actObj.name)
            
    if len(obList) > 0:
        for ob in bpy.context.scene.objects:
            if ob.name in obList:
                font = None
                for f in bpy.data.fonts:
                    if a == f.filepath:
                        font = f
                        break

                if not font:
                    font_name_with_ext = os.path.basename(a)
                    font_name = os.path.splitext(font_name_with_ext)[0]
                    font = bpy.data.fonts.get(font_name)

                if not font:
                    try:
                        font = bpy.data.fonts.load(a)
                    except:
                        if self:
                            self.report({'ERROR'}, "Unsupported Font format!")

                if font:
                    ob.data.font = font
                    if self:
                        self.report({'INFO'}, "Font has been applied")

        for f in bpy.data.fonts:
            if f.users == 0:
                bpy.data.fonts.remove(f, do_unlink=True)
    
def __1__():
    wm = bpy.context.window_manager
    font = wm.fm_fonts_collection[wm.fm_fonts_collection_index]
    __0__(font.path)
    
def __2__(self):
    fm_props = __e__()
    page = fm_props.go_to_page
    
    if page > self.pMax:
        self.report({'ERROR'}, "Page number should be between 1 and "+str(self.pMax))
    else:
        url_parts = urlparse(fm_props.active_page)
        
        query_params = parse_qs(url_parts.query)
        
        query_params['page'] = [page]
        
        new_query_string = urlencode(query_params, doseq=True)
        
        new_url_parts = url_parts._replace(query=new_query_string)
        new_url = urlunparse(new_url_parts)
        
        fm_props.active_page = new_url
        
def __3__(a):
    cleaned_string = "_"+a
    return cleaned_string
    
def __4__(s):
    if os.path.exists(s):
        return True
    
    if os.path.isabs(s):
        return True
    
    if any(c in s for c in ('/', '\\', ':')):
        return True
    
    common_extensions = ('.txt', '.pdf', '.doc', '.docx', '.xls', '.xlsx', '.jpg', '.png', '.gif', '.zip', '.tar', '.gz', '.ttf', '.otf', '.ttc')
    if s.lower().endswith(common_extensions):
        return True
    
    return False
    
def __5__(a):
    fm_props = __e__()

    sort_by_map = {
        "1": "alpha",
        "2": "pop",
        "3": "date"
    }
    a += f"&sort={sort_by_map[fm_props.sortBy]}"

    num_fonts_map = {
        "1": "25",
        "2": "50",
        "3": "100",
        "4": "200"
    }
    a += f"&fpp={num_fonts_map[fm_props.numFonts]}"

    filters = {
        "show_pD": "l[]=10",
        "show_fR": "l[]=1",
        "show_pU": "l[]=6",
        "show_dW": "l[]=13",
        "show_sW": "l[]=2",
        "show_dM": "l[]=3",
        "show_uK": "l[]=0"
    }

    for prop, param in filters.items():
        if getattr(fm_props, prop):
            a += f"&{param}"

    if a.endswith('&') or a.endswith('?'):
        a = a[:-1]

    return a
    
def __6__(a):
    try:
        if os.path.exists(a):
            os.remove(a)
            return True
        else:
            return False
    except Exception as e:
        return False
        
def __7__():
    _directory = os.path.dirname(os.path.abspath(__file__))
    return os.path.join(_directory, "web", "downloaded")